#define BLYNK_TEMPLATE_ID 
#define BLYNK_TEMPLATE_NAME 
#define BLYNK_AUTH_TOKEN 
#include <Adafruit_CircuitPlayground.h>

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT SerialUSB

bool thankYouSent = false;
bool textSent = false;

#include <ESP8266_Lib.h>
#include <BlynkSimpleShieldEsp8266.h>

// Your WiFi credentials.
// Set password to "" for open networks.
char ssid[] = "";
char pass[] = "";

// Hardware Serial on Mega, Leonardo, Micro...
#define EspSerial Serial1

// or Software Serial on Uno, Nano...
//#include <SoftwareSerial.h>
//SoftwareSerial EspSerial(2, 3); // RX, TX

// Your ESP8266 baud rate:
#define ESP8266_BAUD 115200

ESP8266 wifi(&EspSerial);

// This function will be called every time Slider Widget
// in Blynk app writes values to the Virtual Pin V1
BLYNK_WRITE(V0)
{
  int pinValue = param.asInt(); // assigning incoming value from pin V1 to a variable
  
  turnOnGreenLights(pinValue);
  // process received value
  updateTemperatureGauge();
}

BLYNK_WRITE(V3)
{
  int pinValue = param.asInt();

  if (pinValue == 1 && !thankYouSent)
  {
    thankYouSent = true;
    
    Blynk.virtualWrite(V0, 0);
    turnOnGreenLights(0);
    String message = "T";
  
    Blynk.virtualWrite(V1, message); 
  }
}

void setup()
{
  CircuitPlayground.begin();
  // Debug console
  SerialUSB.begin(115200);

  // Set ESP8266 baud rate
  EspSerial.begin(ESP8266_BAUD);
  delay(10);

  Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass);
  // You can also specify server:
  //Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass, "blynk.cloud", 80);
  //Blynk.begin(BLYNK_AUTH_TOKEN, wifi, ssid, pass, IPAddress(192,168,1,100), 8080);
}

void loop()
{
  //Serial.println("i was here1");
  Blynk.run();
  // You can inject your own code or combine it with other sketches.
  // Check other examples on how to communicate with Blynk. Remember
  // to avoid delay() function!
  measureLight();
}

void turnOnGreenLights(int y)
{
  if (y == 1)
  {
    setAllColors(0, 255, 0);
  }
  else
  {
    setAllColors(0, 0, 0);
  }
}

void setAllColors(int i_Red, int i_Green, int i_Blue)
{
  CircuitPlayground.setPixelColor(1, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(2, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(3, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(4, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(5, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(6, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(7, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(8, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(9, i_Red, i_Green, i_Blue);
  CircuitPlayground.setPixelColor(0, i_Red, i_Green, i_Blue);
}

void measureLight()
{
  int currentLightMeasurement = CircuitPlayground.lightSensor();
  
  if (currentLightMeasurement > 100 && !textSent)
  {
    textSent = true;
    String message = "M"; // prefix for sending mail
    Serial.println("i was here");

    Blynk.virtualWrite(V1, message);
  }  
}

void updateTemperatureGauge()
{
  int temperatureReading = CircuitPlayground.temperature();

  Blynk.virtualWrite(V2, temperatureReading);
}
